import time
import threading
from Level2Game import Level2Game

class Level1Game:
    def __init__(self, motorgame):

        #Sets the right widgets for the start of level 1
        motorgame.MainWindows.setCurrentWidget(motorgame.Level1)
        motorgame.level1Pages.setCurrentWidget(motorgame.page)
        motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)

        #Defining variables
        global level1
        global Correct1
        self.Correct1=0
        self.level1 = 0

        #Begins the thread
        self.begin(motorgame)
        
        #Buttons are defined
        motorgame.buttonHome.clicked.connect(lambda:self.Home(motorgame))
        motorgame.Level1NotCompleteHome.clicked.connect(lambda:self.Home(motorgame))
        motorgame.buttonHome_4.clicked.connect(lambda:self.Home1Complete(motorgame))
        motorgame.Level1CompleteHome.clicked.connect(lambda:self.Home1Complete(motorgame))
        motorgame.buttonReset.clicked.connect(lambda:self.Reset(motorgame))
        motorgame.buttonReset_4.clicked.connect(lambda:self.Reset(motorgame))
            
    
    #What happens if the restart buttons are pressed, the game is restarted    
    def Reset(self,motorgame):
        if self.Correct1==0:
            motorgame.level1Pages.setCurrentWidget(motorgame.page)
            motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
            self.level1=0
        else:
            motorgame.level1Pages.setCurrentWidget(motorgame.page)
            motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
            time.sleep(1)
            self.Correct1=0
            self.level1=0
            self.begin(motorgame)
    
    #Changes to Level select page if the home menus are pressed
    def Home(self,motorgame):
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_LevelSelect)
        self.Correct1=1

    #Changes to the correct Level select page if the home menus are pressed in a completed level
    def Home1Complete(self,motorgame):
        print(motorgame.level2Game)
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        if motorgame.level2Game ==0:
            motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level1Complete)
            self.Correct1 = 1
        elif motorgame.level3Game==0:
            motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level2Complete)
            self.Correct1 = 1
        else:
            motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level3Complete)
            self.Correct1=1

    #Function with the main logic of the game where the sensors are handled
    def func(self,motorgame):
        while self.Correct1==0:
            time.sleep(0.01)
            if motorgame.ser.in_waiting >0: #Checking if something is sent from the arduino
                line = motorgame.ser.readline().decode('utf-8').strip('\n\r')
                sensordatasplit = line.split(',')
                ProxSensor1 = sensordatasplit[0]
                ProxSensor2 = sensordatasplit[1]
                ProxSensor3 = sensordatasplit[2]

                if ProxSensor1=="0" and self.level1 ==0:
                    print("1 blocked")
                    motorgame.messageWidgets.setCurrentWidget(motorgame.CorrectWidget)
                    time.sleep(1)
                    motorgame.level1Pages.setCurrentWidget(motorgame.page_2)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
                    self.level1=1
                    time.sleep(1)
                elif ProxSensor1 == "0" and self.level1 == 1:
                    motorgame.messageWidgets.setCurrentWidget(motorgame.IncorrectWidget)
                    time.sleep(2)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
                elif (ProxSensor2=="0" or ProxSensor3 =="0") and self.level1==0:       
                    motorgame.messageWidgets.setCurrentWidget(motorgame.IncorrectWidget)
                    time.sleep(2)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
                    
                if ProxSensor2 =="0" and self.level1==1:
                    print("2 Blocked")
                    motorgame.messageWidgets.setCurrentWidget(motorgame.CorrectWidget)
                    time.sleep(1)
                    motorgame.level1Pages.setCurrentWidget(motorgame.page_3)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
                    self.level1=2
                    time.sleep(1)
                elif (ProxSensor1=="0" or ProxSensor2=="0") and self.level1==2:
                    motorgame.messageWidgets.setCurrentWidget(motorgame.IncorrectWidget)
                    time.sleep(2)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)
                elif ProxSensor3=="0" and self.level1==1:
                    motorgame.messageWidgets.setCurrentWidget(motorgame.IncorrectWidget)
                    time.sleep(2)
                    motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget)

                if ProxSensor3 =="0" and self.level1==2:
                    print("3 Blocked")
                    motorgame.messageWidgets.setCurrentWidget(motorgame.CompletedWidget)
                    time.sleep(1)
                    self.level1=3
                    motorgame.level1Menu.setCurrentWidget(motorgame.menulevel1Complete)
                    self.Correct1=1
                    
        motorgame.ser.reset_input_buffer()
        return          
                         
    #Starts the thread       
    def begin(self,motorgame):
        t1 = threading.Thread(target=self.func, args=(motorgame,))
        t1.start()    