import time
import threading 
from Level3Game import Level3Game

class Level2Game:
    def __init__(self, motorgame):
        
        #Sets the right widgets for the start of level 2
        motorgame.MainWindows.setCurrentWidget(motorgame.Level2)
        motorgame.level2Pages.setCurrentWidget(motorgame.page_4)
        motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
        
        #Defining variables
        global level2
        global Correct2
        self.Correct2 = 0
        self.level2 = 0

        #Begins the thread
        self.begin2(motorgame)
        
        #Buttons are defined
        motorgame.buttonHome_2.clicked.connect(lambda:self.Home(motorgame))
        motorgame.Level2NotCompleteHome.clicked.connect(lambda:self.Home(motorgame))
        motorgame.buttonHome_3.clicked.connect(lambda:self.Home2Complete(motorgame))
        motorgame.Level2CompleteHome.clicked.connect(lambda:self.Home2Complete(motorgame))
        motorgame.buttonReset_2.clicked.connect(lambda:self.Reset(motorgame))
        motorgame.buttonReset_3.clicked.connect(lambda:self.Reset(motorgame))
        
    #What happens if the restart buttons are pressed, the game is restarted  
    def Reset(self,motorgame):
        if self.Correct2==0:
            motorgame.level2Pages.setCurrentWidget(motorgame.page_4)
            motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
            self.level2=0
        else:
            motorgame.level1Pages.setCurrentWidget(motorgame.page_4)
            motorgame.messageWidgets.setCurrentWidget(motorgame.blankWidget_2)
            time.sleep(1)
            self.Correct2=0
            self.level2=0
            self.begin2(motorgame)
        
    #Changes to Level select page if the home menus are pressed
    def Home(self,motorgame):
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level1Complete)
        self.Correct2=1

    #Changes to the correct Level select page if the home menus are pressed in a completed level    
    def Home2Complete(self,motorgame):
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        if motorgame.level3Game ==0:
            motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level2Complete)
            self.Correct2 = 1
        elif motorgame.level3Game == 1:
            motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level3Complete)
            self.Correct2=1
        
    #Function with the main logic of the game where the sensors are handled
    def func2(self,motorgame):
        while self.Correct2==0:
            time.sleep(0.01)
            if motorgame.ser.in_waiting >0: #Checking if something is sent from the arduino
                line = motorgame.ser.readline().decode('utf-8').strip('\n\r')
                sensordatasplit = line.split(',')
                ProxSensor2 = sensordatasplit[0]
                ProxSensor1 = sensordatasplit[1]
                ProxSensor3 = sensordatasplit[2]

                if ProxSensor1=="0" and self.level2 ==0:
                    print("1 blocked")
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.CorrectWidget_2)
                    time.sleep(1)
                    motorgame.level2Pages.setCurrentWidget(motorgame.page_5)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2) 
                    self.level2=1
                    time.sleep(1)
                elif ProxSensor1=="0" and self.level2==1:
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.IncorrectWidget_2)
                    self.level2=0
                    time.sleep(3)
                    motorgame.level2Pages.setCurrentWidget(motorgame.page_4)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
                elif (ProxSensor2=="0" or ProxSensor3 =="0") and self.level2==0:
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.IncorrectWidget_2)
                    time.sleep(2)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
                    
                if ProxSensor2 =="0" and self.level2==1:
                    print("2 blocked")
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.CorrectWidget_2)
                    time.sleep(1)
                    motorgame.level2Pages.setCurrentWidget(motorgame.page_6)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
                    self.level2=2
                    time.sleep(1)
                elif (ProxSensor1=="0" or ProxSensor2=="0") and self.level2==2:
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.IncorrectWidget_2)   
                    self.level2=0
                    time.sleep(2)
                    motorgame.level2Pages.setCurrentWidget(motorgame.page_4)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)               
                elif ProxSensor3=="0" and self.level2==1:
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.IncorrectWidget_2)
                    self.level2=0
                    time.sleep(2)
                    motorgame.level2Pages.setCurrentWidget(motorgame.page_4)
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.blankWidget_2)
                
                if ProxSensor3 =="0" and self.level2==2:
                    print("3 blocked")
                    motorgame.messageWidgets_2.setCurrentWidget(motorgame.CompletedWidget_2)
                    time.sleep(1)
                    self.level2=3
                    motorgame.level2Menu.setCurrentWidget(motorgame.menulevel2Complete)
                    self.Correct2=1

        motorgame.ser.reset_input_buffer()
        return self.Correct2      

    #Starts the thread      
    def begin2(self,motorgame):
        t2 = threading.Thread(target=self.func2, args=(motorgame,))
        t2.start()