import time
import threading
from PySide2.QtCore import *
from PySide2.QtGui import *
from PySide2.QtWidgets import *

class Level3Game:
    def __init__(self, motorgame):

        #Sets the right widgets for the start of level 3
        motorgame.MainWindows.setCurrentWidget(motorgame.Level3)
        motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)

        #Defines the timer
        self.starttime = time.time()
        font6 = QFont()
        font6.setPointSize(22)
        font6.setBold(False)
        font6.setItalic(False)
        font6.setWeight(50)
        motorgame.label_5.setFont(font6)
        motorgame.label_5.setAlignment(Qt.AlignCenter)
        
        #Defines variables
        global level3
        global Correct3
        self.Correct3 = 0
        self.level3 = 0

        #Begins the thread
        self.begin3(motorgame)
        
        #Buttons are defined
        motorgame.buttonHome_5.clicked.connect(lambda:self.Home(motorgame))
        motorgame.Level3NotCompleteHome.clicked.connect(lambda:self.Home(motorgame))
        motorgame.buttonHome_6.clicked.connect(lambda:self.Home3Complete(motorgame))
        motorgame.Level3CompleteHome.clicked.connect(lambda:self.Home3Complete(motorgame))
        motorgame.buttonReset_5.clicked.connect(lambda:self.Reset(motorgame))
        motorgame.buttonReset_6.clicked.connect(lambda:self.Reset(motorgame))
        
    #What happens if the restart buttons are pressed, the game is restarted 
    def Reset(self,motorgame):
        motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
        self.level3=0
    
    #Changes to Level select page if the home menus are pressed
    def Home(self,motorgame):
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level2Complete)
        self.Correct3=1
        
    #Changes to the correct Level select page if the home menus are pressed in a completed level     
    def Home3Complete(self,motorgame):
        motorgame.MainWindows.setCurrentWidget(motorgame.Home)
        motorgame.levelButtonPages.setCurrentWidget(motorgame.Page_Level3Complete)
        self.Correct3=1
      
    #Function with the main logic of the game where the sensors are handled
    def func3(self,motorgame):
        while self.Correct3==0:

            #Setting the timer
            self.countdown = round(60-(time.time()-self.starttime),0)
            motorgame.label_5.setText(str(self.countdown))
            time.sleep(0.01)
            if self.countdown == 0:
                break

            if motorgame.ser.in_waiting >0: #Checking if something is sent from the arduino
                line = motorgame.ser.readline().decode('utf-8').strip('\n\r')
                sensordatasplit = line.split(',')
                ProxSensor3 = sensordatasplit[0]
                ProxSensor2 = sensordatasplit[1]
                ProxSensor1 = sensordatasplit[2]

                if ProxSensor1=="0" and self.level3 ==0:
                    print("1 blocked")
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.CorrectWidget_3)
                    time.sleep(1)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
                    self.level3=1
                    time.sleep(1)
                elif ProxSensor1=="0" and self.level3==1:
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.IncorrectWidget_3)
                    self.level3=0
                    time.sleep(2)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
                elif (ProxSensor2=="0" or ProxSensor3 =="0") and self.level3==0:
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.IncorrectWidget_3)
                    time.sleep(2)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
                    self.level3=0
                    time.sleep(1)
                    
                if ProxSensor2 =="0" and self.level3==1:
                    print("2 blocked")
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.CorrectWidget_3)
                    time.sleep(1)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
                    self.level3=2
                    time.sleep(1)
                elif (ProxSensor1=="0" or ProxSensor2=="0") and self.level3==2:
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.IncorrectWidget_3)
                    self.level3=0
                    time.sleep(2)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)              
                elif ProxSensor3=="0" and self.level3==1:
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.IncorrectWidget_3)
                    self.level3=0
                    time.sleep(2)
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.blankWidget_3)
                
                if ProxSensor3 =="0" and self.level3==2:
                    print("3 blocked")
                    motorgame.messageWidgets_3.setCurrentWidget(motorgame.CompletedWidget_3)
                    time.sleep(1)
                    self.level3=3
                    motorgame.level3Menu.setCurrentWidget(motorgame.menulevel3Complete)
                    self.Correct3=1

        motorgame.ser.reset_input_buffer()
        return self.Correct3     
             
    #Starts the thread     
    def begin3(self,motorgame):
        t3 = threading.Thread(target=self.func3, args=(motorgame,))
        t3.start()