#!/usr/bin/env python3
import serial
import time 

ser = serial.Serial('/dev/ttyACM0', 9600, timeout=1.0) #open serial communication with arduino (port,baudrate 115200)
time.sleep(3) #Seconds, enough time for the arduino to have the serial ready to communicate
ser.reset_input_buffer() #Data arrives in a buffer, resetting the input buffer
print("Serial ok")

try:
    while True:
        time.sleep(0.01) #Loop will be executed 100 times pr second
        if ser.in_waiting >0: #Checking if something is sent from the arduino
            line = ser.readline().decode('utf-8').strip('\n\r')
            sensordatasplit = line.split(',')
            ProxSensor1 = sensordatasplit[0]
            ProxSensor2 = sensordatasplit[1]
            ProxSensor3 = sensordatasplit[2]
            if ProxSensor2=="0":
                print('something is blocking sensor 2!')
            if ProxSensor1=="0":
                print('something is blocking sensor 1!')
            if ProxSensor3=="0":
                print('something is blocking sensor 3!')
            
            
except KeyboardInterrupt: #Ctr + C
    print("Serial communication closed")
    ser.close() #Closing the communication
    