#!/usr/bin/env python3
import serial
import time 

ser = serial.Serial('/dev/ttyACM0', 9600, timeout=1.0) #open serial communication with arduino (port,baudrate 115200)
time.sleep(3) #Seconds, enough time for the arduino to have the serial ready to communicate
ser.reset_input_buffer() #Data arrives in a buffer, resetting the input buffer
print("Serial ok")

IsLevel1Finished = 0
IsLevel2Finished = 0

def Level1(Correct1,level1):
    while Correct1==0:
        time.sleep(0.01)
        if ser.in_waiting >0: #Checking if something is sent from the arduino
            line = ser.readline().decode('utf-8').strip('\n\r')
            sensordatasplit = line.split(',')
            ProxSensor1 = sensordatasplit[0]
            ProxSensor2 = sensordatasplit[1]
            ProxSensor3 = sensordatasplit[2]
            if ProxSensor1 =="0" and level1 == 0:
                print("Sensor 1 is blocked, Correct!")
                level1=1
            elif ProxSensor1=="0" and level1==1:
                print("Not correct, try again")
            elif (ProxSensor2=="0" or ProxSensor3=="0") and level1==0:
                print("Not correct, try again")
                
            if ProxSensor2 =="0" and level1==1:
                print("Sensor 2 is blocked, Correct")
                level1=2
            elif (ProxSensor1=="0" or ProxSensor2=="0") and level1==2:
                print("Not correct, try again")
            elif ProxSensor3=="0" and level1==1:
                print("Not correct, try again")

            if ProxSensor3 =="0" and level1==2:
                print("Sensor 3 is blocked, Correct")          
                print()
                time.sleep(1)
                print("You completed level 1!")
                level1=3
                        
            while level1==3:
                print("Want to do it again?")
                userInput = input("y or n:")
                if userInput=="y":
                    level1=0
                else:
                    Correct1=1
                    level1=0
                    return Correct1          
                             
def Level2(Correct2,level2):
    while Correct2==0:
        time.sleep(0.01)
        if ser.in_waiting >0: #Checking if something is sent from the arduino
            line = ser.readline().decode('utf-8').strip('\n\r')
            sensordatasplit = line.split(',')
            ProxSensor1 = sensordatasplit[0]
            ProxSensor2 = sensordatasplit[1]
            ProxSensor3 = sensordatasplit[2]
            if ProxSensor2 =="0" and level2 == 0:
                print("Sensor 2 is blocked, Correct!")
                level2=1
            elif (ProxSensor1=="0" or ProxSensor3=="0") and level2==0:
                print("Not correct, try again")
            elif ProxSensor2=="0" and level2==1:
                print("Not correct, try again")
                level2=0

            if ProxSensor1 =="0" and level2==1:
                print("Sensor 1 is blocked, Correct")
                level2=2
            elif (ProxSensor2=="0" or ProxSensor1=="0") and level2==2:
                print("Not correct, try again")
                level2=0
            elif ProxSensor3=="0" and level2==1:
                print("not correct, try again")
                level2=0
            
            if ProxSensor3=="0" and level2==2:
                print("Sensor 3 is blocked, correct")
                print()
                time.sleep(1)
                print("You completed level 2!")
                level2=3
                
            while level2==3:
                print("Want to do it again?")
                userInput = input("y or n:")
                if userInput=="y":
                    level2=0
                else:
                    Correct2=1
                    level2=0
                    return Correct2
       
def Level3(Correct3,level3):
    print("level3")
     
try:
    while True:
        time.sleep(0.01) #Loop will be executed 100 times pr second
        UserInput_level = input("level 1, 2 or 3? or quit (q):")
        if IsLevel1Finished ==0 and IsLevel2Finished ==0:
            if UserInput_level == "1":
                IsLevel1Finished = Level1(0,0)
            elif UserInput_level =="2" or UserInput_level =="3":
                print("You have to complete level 1 before doing the others")
            elif UserInput_level =="q":
                print("closed")
                ser.close()
                break
            else:
                print("invalid number")
                        
        elif IsLevel1Finished ==1 and IsLevel2Finished ==0:
            if UserInput_level=="1":
                Level1(0,0)
            elif UserInput_level=="2":
                IsLevel2Finished = Level2(0,0)
            elif UserInput_level=="3":
                print("You have to complete level 2 before doing level 3")
            elif UserInput_level =="q":
                print("closed")
                ser.close()
                break
            else:
                print("Invalid number")
                
        elif IsLevel1Finished==1 and IsLevel2Finished==1:
            if UserInput_level=="1":
                Level1(0,0)
            elif UserInput_level=="2":
                Level2(0,0)
            elif UserInput_level=="3":
                Level3(0,0)
            elif UserInput_level =="q":
                print("closed")
                ser.close()
                break
            else:
                print("Invalid number")            

except KeyboardInterrupt: #Ctr + C
            print("Serial communication closed")
            ser.close() #Closing the communication