from ui_MotorSkillGame import Ui_MotorSkillGame
from PySide2.QtWidgets import QWidget
from threading import Timer
from Level1Game import Level1Game
from Level2Game import Level2Game
from Level3Game import Level3Game
import serial
import time

class game(QWidget, Ui_MotorSkillGame):
    def __init__(self):
        super().__init__()
        self.setupUi(self)
        self.ser = serial.Serial('/dev/ttyACM0', 9600, timeout=10.0) #open serial communication with arduino (port,baudrate 115200)
        time.sleep(3) #Seconds, enough time for the arduino to have the serial ready to communicate
        self.ser.reset_input_buffer() #Data arrives in a buffer, resetting the input buffer
        print("Serial ok")

        global level2Game
        self.level2Game = 0
        global level3Game
        self.level3Game = 0

        #Defining the Start button
        self.StartButton.clicked.connect(self.StartGame)
        
        #Buttons that are not going to be able to press
        self.Button_Level2.clicked.connect(self.ButtonErrorMessage)
        self.Button_Level3.clicked.connect(self.ButtonErrorMessage)        
        self.Button_Level31.clicked.connect(self.ButtonErrorMessage)
        
        #Buttons to start level1
        self.Button_Level1.clicked.connect(self.Level1Game)
        self.Button_Level11.clicked.connect(self.Level1Game)
        self.Button_Level12.clicked.connect(self.Level1Game)
        self.Button_Level13.clicked.connect(self.Level1Game)
        
        #Buttons to start level2
        self.Button_Level21.clicked.connect(self.Level2Game)
        self.Button_Level22.clicked.connect(self.Level2Game)
        self.Button_Level23.clicked.connect(self.Level2Game)
        
        #Buttons to press to start level3
        self.Button_Level32.clicked.connect(self.Level3Game)
        self.Button_Level33.clicked.connect(self.Level3Game)
 
    #Close event, if the user exit the window
    #Based on the code from https://stackoverflow.com/a/9249527
    def closeEvent(self, event):
        can_exit= True
        if can_exit:
            print("Serial closed")
            self.ser.close()
        else:
            event.ignored()

    #Changes widget when the Start button is pressed to the level select page    
    def StartGame(self):
        self.levelButtonPages.setCurrentWidget(self.Page_LevelSelect)

    #What happens if you press red buttons on the level select page
    def ButtonErrorMessage(self):
        btn = self.sender()
        buttonName = btn.objectName()
        timer = Timer(3,lambda:self.Label_LevelSelect.setText(""))
        if buttonName == "Button_Level2" or buttonName == "Button_Level3":
            self.Label_LevelSelect.setText("You have to complete level 1 first")
            timer.start()
        if buttonName == "Button_Level31":
            self.Label_Level1Complete.setText("You have to complete level 2 first")
            timer.start()
    
    #When the Level 1 buttons are pressed, the level is started
    def Level1Game(self):
        btn = self.sender()
        buttonName = btn.objectName()
        if buttonName == "Button_Level1":
            self.ser.reset_input_buffer()
            self.level1Menu.setCurrentWidget(self.menu1NotComplete)
            self.level1Game = Level1Game(self)   
        else:
            self.ser.reset_input_buffer()
            self.level1Menu.setCurrentWidget(self.menulevel1Complete)
            self.level1Game = Level1Game(self)

    #When the Level 2 buttons are pressed, the level is started
    def Level2Game(self):
        btn = self.sender()
        buttonName = btn.objectName()
        if buttonName == "Button_Level21":
            self.ser.reset_input_buffer()
            self.level2Menu.setCurrentWidget(self.menuNotComplete)
            self.level2Game = Level2Game(self)
        else:
            self.ser.reset_input_buffer()
            self.level2Menu.setCurrentWidget(self.menulevel2Complete)
            self.level2Game = Level2Game(self)

    #When the Level 3 buttons are pressed, the level is started    
    def Level3Game(self):
        btn = self.sender()
        buttonName = btn.objectName()
        if buttonName == "Button_Level32":
            self.ser.reset_input_buffer()
            self.level3Menu.setCurrentWidget(self.menuNotComplete_2)
            self.level3Game = Level3Game(self) 
        else:
            self.ser.reset_input_buffer()
            self.level3Menu.setCurrentWidget(self.menulevel3Complete)
            self.level3Game = Level3Game(self)